{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends 'flux/detail.html.twig' %}

{% block subcontent %}
    <div class="box no-border">
        <div class="box-body p-0">

            {% if revisions|length > 0 %}
                <table class="table table-responsive m-b-0 table-rulesets">
                    <thead>
                    <tr>
                        <th style="width: 1px">Version</th>
                        <th>Création</th>
                        <th>Modification</th>
                        <th>Statut</th>
                        <th width="1">Opérations</th>
                    </tr>
                    </thead>
                    <tbody>
                        {% for revision in revisions %}
                            {% set STATUS_PENDING = constant('STATUS_PENDING', revision) %}
                            {% set STATUS_DRAFT = constant('STATUS_DRAFT', revision) %}
                            {% set STATUS_ACTIVE = constant('STATUS_ACTIVE', revision) %}
                            {% set STATUS_ARCHIVED = constant('STATUS_ARCHIVED', revision) %}

                            {% if revision.version == flux.alignmentRuleset.draftVersion and revision.status == constant('AppBundle\\Entity\\AlignmentRulesetRevision::STATUS_PENDING') %}
                                {% set status = STATUS_PENDING %}
                            {% elseif revision.version == flux.alignmentRuleset.draftVersion %}
                                {% set status = STATUS_DRAFT %}
                            {% elseif revision.version == flux.alignmentRuleset.activeVersion %}
                                {% set status = STATUS_ACTIVE %}
                            {% else %}
                                {% set status = STATUS_ARCHIVED %}
                            {% endif %}
                            <tr class="status-{{ status }}">
                                <th class="text-center" data-revision-id="{{ revision.id }}"><span class="badge">{{ revision.version }}</span></th>
                                <td>
                                    {{- revision.createdAt | date('d/m/Y') }} - {{ revision.author is not null ? revision.author.fullName : 'Utilisateur supprimé' -}}
                                </td>
                                <td>
                                    {{- revision.updatedAt | date('d/m/Y à H:i') }} - {{ revision.updater is not null ? revision.updater.fullName : 'Utilisateur supprimé' -}}
                                </td>
                                <td>
                                    <div class="pull-right">
                                        {% set link_comment = is_granted('alignment_ruleset_revision.edit', revision) or revision.comment is not empty %}
                                        {% if link_comment %}<a href="{{ path('flux.ruleset.revision.comment', {id: flux.id, revision_id: revision.id}) }}" data-toggle="modal-remote">{% endif -%}
                                            <i {{ revision.comment is not empty ? 'class="fa fa-comment text-yellow" title="Lire le commentaire est attaché à cette révision"' : 'class="fa fa-comment-o text-muted" title="Il n\'y a pas de commentaire est attaché à cette révision"' }}></i>
                                        {%- if link_comment %}</a>{% endif %}
                                    </div>
                                    <span class="label label-ruleset status-{{ status }}" data-tooltip='{"side":"left"}' title="{{ revision.statusDefinitions[status][1] }}">
                                        <i class="fa fa-fw"></i> {{ revision.statusDefinitions[status][0] }}
                                    </span>
                                </td>
                                <td style="white-space:nowrap">
                                    <!--div class="btn-group btn-group-xs" role="group"-->
                                    {% if status == STATUS_PENDING and revision.hasRules() %}
                                        {% if is_granted("flux.preview", flux) %}
                                            <a href="{{ path('flux.ruleset.revision.preview', {id: flux.id, revision_id: revision.id}) }}" data-toggle="modal-remote" class="btn btn-default btn-xs"><i class="fa fa-eye"></i> Aperçu</a>
                                        {% endif %}
                                        {% if is_granted('alignment_ruleset_revision.validate') %}
                                            <a href="{{ path('flux.ruleset.revision.validate', {id: flux.id, revision_id: revision.id}) }}" data-toggle="modal-remote" class="btn btn-success btn-xs"><i class="fa fa-check"></i> Valider</a>
                                        {% endif %}
                                        {% if is_granted("alignment_ruleset_revision.submit", revision) %}
                                            <a href="{{ path('flux.ruleset.revision.unsubmit', {id: flux.id, revision_id: revision.id}) }}" data-toggle="modal-remote" class="btn btn-danger btn-xs"><i class="fa fa-times"></i> Annuler</a>
                                        {% endif %}
                                        <!--a href="#" class="btn btn-danger btn-xs">Annuler la demande d'activation</a-->
                                    {% elseif status == STATUS_DRAFT %}
                                        {% if is_granted("alignment_ruleset_revision.edit", revision) %}
                                            <a href="{{ path('flux.ruleset.revision.editor', {id: flux.id, revision_id: revision.id}) }}" class="btn btn-primary btn-xs"><i class="fa fa-pencil"></i> Modifier</a>
                                        {% endif %}
                                        {% if revision.hasRules() and is_granted("alignment_ruleset_revision.submit", revision) %}
                                            <a href="{{ path('flux.ruleset.revision.submit', {id: flux.id, revision_id: revision.id}) }}" data-toggle="modal-remote" class="btn btn-success btn-xs"><i class="fa fa-check"></i> Demander l'activation</a>
                                        {% endif %}
                                        {% if is_granted("alignment_ruleset_revision.delete", revision) %}
                                            <a href="{{ path('flux.ruleset.revision.remove', {id: flux.id, revision_id: revision.id}) }}" data-toggle="modal-remote" class="btn btn-danger btn-xs"><i class="fa fa-trash"></i> Supprimer</a>
                                        {% endif %}
                                    {% elseif status == STATUS_ACTIVE %}
                                        {% if is_granted('alignment_ruleset_revision.create', flux) and not flux.alignmentRuleset.draftVersion %}
                                            <a href="{{ path('flux.ruleset.revision.create', {id: flux.id}) }}" class="btn btn-primary btn-xs">Créer une nouvelle révision</a>
                                        {% endif %}
                                    {% elseif status == STATUS_ARCHIVED %}
                                        <!--a href="#" class="btn btn-default btn-xs">Revenir à cette version</a-->
                                    {% endif %}
                                    <!--/div-->
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <div class="blankslate blankslate-spacious">
                    <h3>Aucun jeu de règles d'alignement n'a encore été défini pour ce flux.</h3>
                    {% if is_granted('alignment_ruleset_revision.create', flux) %}
                        <a href="{{ path('flux.ruleset.create', {id: flux.id}) }}" class="btn m-t-20 btn-primary">Créer un nouveau jeu de règles</a>
                    {% endif %}
                </div>
            {% endif %}
        </div>
    </div>
{% endblock %}